rawset(_G, "bounce", true)
COM_AddCommand("um_bounce", function(p, arg)
	local v = UM_StrBool(arg)
	if v ~= nil then bounce = v
	else
		CONS_Printf(p, "um_bounce [on/off] - Toggles whether or not you can bounce off of walls after thokking. Currently "
		+ UM_EnabledDisabled(bounce))
	end
end, COM_ADMIN)

addHook("PlayerThink", function(p)
	if not p.riu then
		p.riu = {
			wallhit = 0
		}
	end
	if P_IsObjectOnGround(p.mo) then
		p.riu.wallhit = 2
	end
	if not p.mo then return end
end)

addHook("MobjDamage", function(mo, inf, src)
	if inf and inf.valid and inf.type == MT_PLAYER then
		if (inf.player.charability == CA_THOK or inf.player.charability == CA_FLY) and inf.player.pflags & PF_THOKKED then
			-- Regain the ability to thok
			inf.player.pflags = $ & ~PF_THOKKED
		end
	end
end)

-- Totally not a rebound dash
addHook("MobjMoveBlocked", function(mo)
	local p = mo.player
	if p.charability2 == CA2_MELEE then return end
	local spin = p.pflags & PF_SPINNING
	local thok = (p.charability == CA_THOK) and (p.pflags & PF_THOKKED)
	local tripledash = p.mo.skin == "extralife" and p.tdashcount > 0
	
	if not bounce then return end
	if p.mo.state ~= S_PLAY_JUMP and p.mo.state ~= S_PLAY_ROLL then return end
	if p.speed < 10*mo.scale then return end
	if not (p.speed > 2000000) then return end

	p.pflags = ($ | PF_JUMPED) & ~(PF_SPINNING|PF_THOKKED)
	p.mo.state = S_PLAY_JUMP
	S_StartSound(mo, sfx_clack)
	P_StartQuake(12*FRACUNIT, 3)
	P_BounceMove(mo)
	mo.momx = $/16*17
	mo.momy = $/16*17
	if mo.eflags & MFE_VERTICALFLIP then
		mo.momz = -6*p.mo.scale * p.riu.wallhit
	else
		mo.momz = 6*p.mo.scale * p.riu.wallhit
	end
	if (p.riu.wallhit <= 0) then
		p.pflags = $ | PF_THOKKED
		p.mo.state = S_PLAY_FALL
		mo.momx = $/16
		mo.momy = $/16
	end
	
	p.riu.wallhit = $ - 1

	if p.powers[pw_super] then
		P_Earthquake(p.mo, p.mo, 125*FRACUNIT)
	end
	
	UM_SpawnThok(p)
	
	local dustcount = 6
	while dustcount > 0
		dustcount = $ - 1
		local dust = P_SpawnMobjFromMobj(mo, 0, 0, mo.scale * 18, MT_SPINDUST)
		dust.state = S_MINECARTSPARK
		dust.momx = (mo.momx * 3) + (P_RandomRange(-20,20) * FRACUNIT)
		dust.momy = (mo.momy * 3) + (P_RandomRange(-20,20) * FRACUNIT)
		dust.momz = P_RandomRange(-3,3) * FRACUNIT
		dust.scale = FRACUNIT * P_RandomRange(50,125) / 100
		dust.destscale = 0
		dust.angle = P_RandomRange(0,ANGLE_180)
		dust.fuse = 10
	end
	
end, MT_PLAYER)